using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;

namespace Reversi
{
    public partial class Form1 : Form
    {
        public Form1()   
        {
            InitializeComponent();
        }

      #region Global variable section

        
        int mx = 0;    // mouse horizontal pixel position
        int my = 0;    // mouse vertical position
        int bx = 0;   // column number of mouse
        int by = 0;   // row number of mouse
        int x1 = 0;   // set of global coordinates
        int y1 = 0;
        int x2 = 0;   
        int y2 = 0;   
        int x3 = 0;   
        int y3 = 0;   
        int bsize = 48; // square size
        int cnt = 0;  // counters
        int cnt2 = 0;
        int cnt3 = 0;
        int cnt4 = 0;
        int r1 = 1;  // random numbers or holders of array data
        int r2 = 2;
        int r3 = 3;
        int r4 = 4;
        int r5 = 1;
        int move = 1;
        int cpmove = 0;
        int piece = 0;
        int oldx = 0;
        int oldy = 0;
        int score = 0;
        string dir = "none";
        string dir2 = "none";
        Random rnd = new Random();
        Point[] pt = new Point[11];
        int[,] brd = new int[60, 60];  // Array for holding piece information 
        int[,] brd2 = new int[60, 60]; // layer 2
        int[,] brd3 = new int[60, 60]; // layer 3
        int[,] brd4 = new int[60, 60]; // layer 4
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(20, 20, 50));
        Brush br3 = new SolidBrush(Color.FromArgb(0, 0, 250));
        Brush br4 = new SolidBrush(Color.LightSlateGray);
        Brush br5 = new SolidBrush(Color.DarkSlateGray);
        Brush redbr = new SolidBrush(Color.Red);

        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        Pen bluepen = new Pen(Color.Blue);
        Pen whitepen = new Pen(Color.White);
        Pen redpen = new Pen(Color.Red);
        #endregion

      #region Bitmap Section

        
        static Bitmap bmp1 = new Bitmap(800, 600);
        Graphics z = Graphics.FromImage(bmp1);

        static Bitmap bm1 = new Bitmap(47, 47);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(47, 47);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(47, 47);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(47, 47);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(47, 47);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(47, 47);
        Graphics b6 = Graphics.FromImage(bm6);

        Image sp1 = (Image)(new Bitmap(Reversi.Properties.Resources.PinkPiece));
        Image sp2 = (Image)(new Bitmap(Reversi.Properties.Resources.DarkPiece));
        //Image sp3 = (Image)(new Bitmap(BoxIt.Properties.Resources.green));
        //Image sp4 = (Image)(new Bitmap(BoxIt.Properties.Resources.yellow));
        //Image sp5 = (Image)(new Bitmap(BoxIt.Properties.Resources.purple));
        //Image sp6 = (Image)(new Bitmap(BoxIt.Properties.Resources.cyan));
        #endregion

      #region Event Handlers
        private void Form1_Load(object sender, EventArgs e)
        {
            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);

            brd[5, 5] = 1;
            brd[6, 6] = 1;
            brd[5, 6] = 2;
            brd[6, 5] = 2;
            UpdateScreen();

        }
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(bmp1, 0, 0);
        }
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {

        }
        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / bsize -4;
            by = my / bsize ;


           
            UpdateScreen();
        }
        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            int a = 0;
            

            if (cpmove == 0)
            {
                if (move == 1) // select piece
                {
                    Sounds.Play("laser.wav");
                    Move1();
                    a = 1;
                }
                if (move == 2) if (a == 0) // select square
                    {
                        Sounds.Play("SMACK.wav");
                        Move2();
                    }
            }
            UpdateScreen();
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            if (cpmove == 1)
            {
                ComputerMove();
                

            }
            UpdateScreen();
        }
      #endregion

      #region Player's move
        private void Move1()    // select piece
        {
            piece = brd[bx, by];
            if (piece == 1)
            {
                oldx = bx;
                oldy = by;
                move = 2;
            }
            x2 = 0; y2 = 0;
            brd[2, 2] = 0;
        }
        private void Move2()   // select square for new piece
        {
            int a = 0;
            int b = 0;

            a = IsMoveLegal1( bx , by );          // check direction
            if(a==1) a = IsMoveLegal2(bx, by);    // piece allignment
            if (a == 1)
            {
                brd[bx, by] = piece;
                FlipPieces();
            }
            move = 1;
            cpmove = 1;
        }
        private int IsMoveLegal1(int x, int y)
        {
            int a = 1;
            int dx = 0;
            int dy = 0;

            string dirx = "none"; // direction of x movement
            string diry = "none"; // direction of y movement
            dir = "none";

            if (oldy > y) dy = oldy - y;       // get movement distance
            if (oldy < y) dy = y - oldy;
            if (oldx > x) dx = oldx - x;
            if (oldx < x) dx = x - oldx;

            if (oldy == y && oldx > x && dx > 1) dir = "left";      // horizontal move
            if (oldy == y && oldx < x && dx > 1) dir = "right";
            if (oldx == x && oldy > y && dy > 1) dir = "up";      // vertical move
            if (oldx == x && oldy < y && dy > 1) dir = "down";

            if (oldx > x) dirx = "left";      // x movement
            if (oldx < x) dirx = "right";
            if (oldy > y) diry = "up";      // y movement
            if (oldy < y) diry = "down";

            if (dx == dy && dx > 1)              // diagonal
            {
                if (dirx == "left" && diry == "up") dir = "upleft";
                if (dirx == "left" && diry == "down") dir = "downleft";
                if (dirx == "right" && diry == "up") dir = "upright";
                if (dirx == "right" && diry == "down") dir = "downright";
            }

            if (brd[bx, by] != 0) a = 0;
            if (dir == "none") a = 0;

            return a;
        }
        private int IsMoveLegal2(int bx, int by) // player piece =1 computer=2
        {
            int a = 1;
            int b = 2;
            int c = 0;
            int d = 0;
            ClearPt();
            if (dir == "up")
            {
                b = oldy - 1;
                while (b > by)
                {
                    c = brd[bx, b];
                    pt[b].X = bx;
                    pt[b].Y = b;
                    if (c < 2) a = 0;
                    b = b - 1;
                }
            }
            if (dir == "down")
            {
                b = oldy + 1;
                while (b < by)
                {
                    c = brd[bx, b];
                    pt[b].X = bx;
                    pt[b].Y = b;
                    if (c < 2) a = 0;
                    b = b + 1;
                }

            }
            if (dir == "left")
            {
                b = oldx - 1;
                while (b > bx)
                {
                    c = brd[b, by];
                    pt[b].X = b;
                    pt[b].Y = by;
                    if (c < 2) a = 0;
                    b = b - 1;
                }
            }
            if (dir == "right")
            {
                b = oldx + 1;
                while (b < bx)
                {
                    c = brd[b, by];
                    pt[b].X = b;
                    pt[b].Y = by;
                    if (c < 2) a = 0;
                    b = b + 1;
                }
            }


            if (dir == "upleft")
            {
                b = oldx - 1;
                d = oldy - 1;
                while (b > bx)
                {
                    c = brd[b, d];
                    pt[b].X = b;
                    pt[b].Y = d;
                    if (c < 2) a = 0;
                    b = b - 1;
                    d = d - 1;

                }
            }


            if (dir == "upright")
            {
                b = oldx + 1;
                d = oldy - 1;
                while (b < bx)
                {
                    c = brd[b, d];
                    pt[b].X = b;
                    pt[b].Y = d;
                    if (c < 2) a = 0;
                    b = b + 1;
                    d = d - 1;

                }
            }

            if (dir == "downleft")
            {
                b = oldx - 1;
                d = oldy + 1;
                while (b > bx)
                {
                    c = brd[b, d];
                    pt[b].X = b;
                    pt[b].Y = d;
                    if (c < 2) a = 0;
                    b = b - 1;
                    d = d + 1;

                }
            }
            if (dir == "downright")
            {
                b = oldx + 1;
                d = oldy + 1;
                while (b < bx)
                {
                    c = brd[b, d];
                    pt[b].X = b;
                    pt[b].Y = d;
                    if (c < 2) a = 0;
                    b = b + 1;
                    d = d + 1;

                }
            }

            return a;
        }
        private void ClearPt()
        {
            int a = 0;
            while (a < 9)
            {
                pt[a].X = 0;
                pt[a].Y = 0;
                a = a + 1;
            }
        }
        private void FlipPieces()
        {
            int a = 0;
            while (a < 11)
            {
               if( pt[a].X > 0)brd[pt[a].X,pt[a].Y]=1;
                
                a = a + 1;
            }

        }
        private void Flip2()
        {
            int a = 1;
            int dx = 0;
            int dy = 0;
            int x = 0;
            int y = 0;
            string dirx = "none"; // direction of x movement
            string diry = "none"; // direction of y movement
            dir = "none";


            x = x2;
            y = y2;
            if (y1 > y) dy = y1 - y;       // get movement distance
            if (y1 < y) dy = y - y1;
            if (x1 > x) dx = x1 - x;
            if (x1 < x) dx = x - x1;

            if (y1 == y && x1 > x && dx > 1) dir = "left";      // horizontal move
            if (y1 == y && x1 < x && dx > 1) dir = "right";
            if (x1 == x && y1 > y && dy > 1) dir = "up";      // vertical move
            if (x1 == x && y1 < y && dy > 1) dir = "down";

            if (x1 > x) dirx = "left";      // x movement
            if (x1 < x) dirx = "right";
            if (y1 > y) diry = "up";      // y movement
            if (y1 < y) diry = "down";

            if (dx == dy && dx > 1)              // diagonal
            {
                if (dirx == "left" && diry == "up") dir = "upleft";
                if (dirx == "left" && diry == "down") dir = "downleft";
                if (dirx == "right" && diry == "up") dir = "upright";
                if (dirx == "right" && diry == "down") dir = "downright";
            }

        }
      #endregion

      #region Computer's Move
        private void ComputerMove()
        {
            #region Local Variables

            int a = 0;
            int a1 = 0;
            int a2 = 0;
            int a3 = 0;
            int a4 = 0;
            int a5 = 0;
            int a6 = 0;
            int a7 = 0;
            int a8 = 0;
            int x = 1;
            int y = 1;
            x1 = 0;
            y1 = 0;
            int pce = 0;
           #endregion
            dir2 = "none";
            while (y < 11)
            {
                while (x < 11)
                {
                    pce = brd[x, y];
                    if (pce == 2)            // 2 = computer piece
                    {
                      #region check right

                        a1 = CheckRight(x, y);  // 8 directional scans for each computer piece
                       // x2 = 1; y2 = 1;
                        if (a1 > a)
                        {
                            a = a1;  // move value
                            x1 = x;  // move from
                            y1 = y;
                            x2 = x3;  // move to
                            y2 = y3;
                            dir2 = "right";
                        }
                      #endregion
                      #region check left
 
                        a2 = CheckLeft(x, y);

                        if (a2 > a)
                        {
                            a = a2;  // move value
                            x1 = x;  // move from
                            y1 = y;
                            x2 = x3;  // move to
                            y2 = y3;
                            dir2 = "left";
                        }
                      #endregion
                      #region check up
 
                        a3 = CheckUp(x, y);
                        if (a3 > a)
                        {
                            a = a3;  // move value
                            x1 = x;  // move from
                            y1 = y;
                            x2 = x3;  // move to
                            y2 = y3;
                            dir2 = "up";
                        }
                      #endregion
                      #region check down
 
                        a4 = CheckDown(x, y);
                        if (a4 > a)
                        {
                            a = a4;  // move value
                            x1 = x;  // move from
                            y1 = y;
                            x2 = x3;  // move to
                            y2 = y3;
                            dir2 = "down";
                        }
                      #endregion
                      #region check diagonal up right

                        
                        a5 = CheckUpRight(x, y);
                        if (a5 > a)
                        {
                            a = a5;  // move value
                            x1 = x;  // move from
                            y1 = y;
                            x2 = x3;  // move to
                            y2 = y3;
                            dir2 = "upright";
                        }
                      #endregion
                      #region check diagonal up left
 
                        a6 = CheckUpLeft(x, y);
                        if (a6 > a)
                        {
                            a = a6;  // move value
                            x1 = x;  // move from
                            y1 = y;
                            x2 = x3;  // move to
                            y2 = y3;
                            dir2 = "upleft";
                        }
                      #endregion
                      #region check diagonal down right
  
                        a7 = CheckDownRight(x, y);
                        if (a7 > a)
                        {
                            a = a7;  // move value
                            x1 = x;  // move from
                            y1 = y;
                            x2 = x3;  // move to
                            y2 = y3;
                            dir2 = "downright";
                        }
                      #endregion
                      #region check diagonal down left
 
                        a8 = CheckDownLeft(x, y);
                        if (a8 > a)
                        {
                            a = a8;  // move value
                            x1 = x;  // move from
                            y1 = y;
                            x2 = x3;  // move to
                            y2 = y3;
                            dir2 = "downleft";
                        }
                      #endregion
                    }
                    x = x + 1;
                }
                y = y + 1;
                x = 1;
                
            }
            brd[x2, y2] = 2; // actual computer move
            #region Computer Flip
            if (dir2 == "right")
            {
                while (x1 < x2)
                {
                    brd[x1, y1] = 2;
                    x1 = x1 + 1;
                }
            }
            if (dir2 == "left")
            {
                while (x1 > x2)
                {
                    brd[x1, y1] = 2;
                    x1 = x1 - 1;
                }
            }
            if (dir2 == "up")
            {
                while (y1 > y2)
                {
                    brd[x1, y1] = 2;
                    y1 = y1 - 1;
                }
            }
            if (dir2 == "down")
            {
                while (y1 < y2)
                {
                    brd[x1, y1] = 2;
                    y1 = y1 + 1;
                }
            }
            if (dir2 == "upright")
            {
                while (x1 < x2)
                {
                    brd[x1, y1] = 2;
                    x1 = x1 + 1;
                    y1 = y1 - 1;
                }
            }
            if (dir2 == "upleft")
            {
                while (x1 > x2)
                {
                    brd[x1, y1] = 2;
                    x1 = x1 - 1;
                    y1 = y1 - 1;
                }
            }
            if (dir2 == "downright")
            {
                while (x1 < x2)
                {
                    brd[x1, y1] = 2;
                    x1 = x1 + 1;
                    y1 = y1 + 1;
                }
            }
            if (dir2 == "downleft")
            {
                while (x1 > x2)
                {
                    brd[x1, y1] = 2;
                    x1 = x1 - 1;
                    y1 = y1 + 1;
                }
            }
            #endregion

            cpmove = 0;      // computer move, over
        }
        private int CheckDown(int x, int y)
        {
            int a = 0;
            int b = 0;
            int c = 1;
            int d = 0;
            x3 = 0;
            y3 = 0;
            y = y + 1;    // current location +1
            b = brd[x, y];
            y = y + 1;
            if (b == 1)  // looking for player pieces
            {
                while (y < 11 && c == 1) // start scan at x+2
                {
                    b = brd[x, y]; // 1 = players piece

                    x3 = x;    // holds move location
                    y3 = y;

                    if (b != 1) c = 0; // stop scanning
                    if (b == 0) a = 1; // legal move

                    y = y + 1;
                }

            }
            if (y == 11 && a == 1) a = 10;
            if (y == 9 && a == 1) a = 5;
            if (y == 7 && a == 1) a = 2;
           
            return a;
            
        }
        private int CheckUp(int x, int y)
        {
            #region Setup

            int a = 0;
            int b = 0;
            int c = 1;
            int d = 0;
            x3 = 0;
            y3 = 0;
            y = y - 1;    // current location -1
            b = brd[x, y];
            y = y - 1;
            #endregion
            #region Scan 8 squares up

            if (b == 1)  // looking for player pieces
            {
                while (y > 0 && c == 1) // start scan at x+2
                {
                    b = brd[x, y]; // 1 = players piece
                    x3 = x;    // holds move location
                    y3 = y;
                    if (b != 1) c = 0; // stop scanning
                    if (b == 0) a = 1; // legal move
                    y = y - 1;
                }
            }
            #endregion
            #region Logic

            if (y == 0 && a == 1) a = 10;
            if (y == 2 && a == 1) a = 5;
            if (y == 4 && a == 1) a = 2;
            #endregion

            return a;
        }
        private int CheckLeft(int x, int y)
        {
          #region Setup

            
            int a = 0;
            int b = 0;
            int c = 1;
            int d = 0;
            x3 = 0;
            y3 = 0;
            x = x - 1;    // current location -1
            b = brd[x, y];
            x = x - 1;
          #endregion
          #region Scan 8 squares left
 
            if (b == 1)  // looking for player pieces
            {
                while (x > 0 && c == 1) // start scan at x+2
                {
                    b = brd[x, y]; // 1 = players piece
                    x3 = x;    // holds move location
                    y3 = y;
                    if (b != 1) c = 0; // stop scanning
                    if (b == 0) a = 1; // legal move
                    x = x - 1;
                }
            }
          #endregion
          #region Logic
 
            if (x == 0 && a == 1) a = 10;
            if (x == 2 && a == 1) a = 5;
            if (x == 4 && a == 1) a = 2;
          #endregion
            return a;

        }
        private int CheckRight(int x, int y)
        {
            int a = 0;
            int b = 0;
            int c = 1;
            int d = 0;
            x3 = 0;
            y3 = 0;
            x = x + 1;    // current location +1
            b = brd[x, y];
            x = x + 1;
            if (b == 1)  // looking for player pieces
            {
                while (x < 11 && c == 1) // start scan at x+2
                {
                    b = brd[x, y]; // 1 = players piece

                    x3 = x;    // holds move location
                    y3 = y;

                    if (b != 1) c = 0; // stop scanning
                    if (b == 0) a = 1; // legal move

                    x = x + 1;
                }

            }
            if (x == 11 && a == 1) a = 10;
            if (x == 9 && a == 1) a = 5;
            if (x == 7 && a == 1) a = 2;
            return a;
        }
        private int CheckDownLeft(int x, int y)
        {
            #region Setup


            int a = 0;
            int b = 0;
            int c = 1;
            int d = 0;
            x3 = 0;
            y3 = 0;
            x = x - 1;    // current location -1
            y = y + 1;
            b = brd[x, y];
            x = x - 1;
            y = y + 1;
            #endregion
            #region Scan 8 squares left

            if (b == 1)  // looking for player pieces
            {
                while (x > 0 && c == 1) // start scan at x+2
                {
                    b = brd[x, y]; // 1 = players piece
                    x3 = x;    // holds move location
                    y3 = y;
                    if (b != 1) c = 0; // stop scanning
                    if (b == 0) a = 1; // legal move
                    x = x - 1;
                    y = y + 1;
                }
            }
            #endregion
            #region Logic

            if (x == 0 && a == 1) a = 10;
            if (x == 2 && a == 1) a = 5;
            if (x == 4 && a == 1) a = 2;
            #endregion
            return a;

            
        }
        private int CheckUpLeft(int x, int y)
        {
            #region Setup


            int a = 0;
            int b = 0;
            int c = 1;
            int d = 0;
            x3 = 0;
            y3 = 0;
            x = x - 1;    // current location -1
            y = y - 1;
            b = brd[x, y];
            x = x - 1;
            y = y - 1;
            #endregion
            #region Scan 8 squares left

            if (b == 1)  // looking for player pieces
            {
                while (x > 0 && c == 1) // start scan at x+2
                {
                    b = brd[x, y]; // 1 = players piece
                    x3 = x;    // holds move location
                    y3 = y;
                    if (b != 1) c = 0; // stop scanning
                    if (b == 0) a = 1; // legal move
                    x = x - 1;
                    y = y - 1;
                }
            }
            #endregion
            #region Logic

            if (x == 0 && a == 1) a = 10;
            if (x == 2 && a == 1) a = 5;
            if (x == 4 && a == 1) a = 2;
            #endregion
            return a;

            
        }
        private int CheckDownRight(int x, int y)
        {
            int a = 0;
            int b = 0;
            int c = 1;
            int d = 0;
            x3 = 0;
            y3 = 0;
            x = x + 1;    // current location +1
            y = y + 1;
            b = brd[x, y];
            x = x + 1; y = y + 1;
            if (b == 1)  // looking for player pieces
            {
                while (x < 11 && c == 1) // start scan at x+2
                {
                    b = brd[x, y]; // 1 = players piece

                    x3 = x;    // holds move location
                    y3 = y;

                    if (b != 1) c = 0; // stop scanning
                    if (b == 0) a = 1; // legal move

                    x = x + 1; y = y + 1;
                }

            }
            if (x == 11 && a == 1) a = 10;
            if (x == 9 && a == 1) a = 5;
            if (x == 7 && a == 1) a = 2;
            return a;
            
        }
        private int CheckUpRight(int x, int y)
        {
            int a = 0;
            int b = 0;
            int c = 1;
            int d = 0;
            x3 = 0;
            y3 = 0;
            x = x + 1;    // current location +1
            y = y - 1;
            b = brd[x, y];
            x = x + 1; y = y - 1;
            if (b == 1)  // looking for player pieces
            {
                while (x < 11 && c == 1) // start scan at x+2
                {
                    b = brd[x, y]; // 1 = players piece

                    x3 = x;    // holds move location
                    y3 = y;

                    if (b != 1) c = 0; // stop scanning
                    if (b == 0) a = 1; // legal move

                    x = x + 1; y = y - 1;
                }

            }
            if (x == 11 && a == 1) a = 10;
            if (x == 9 && a == 1) a = 5;
            if (x == 7 && a == 1) a = 2;
            return a;
            
        }
      #endregion

      #region Draw Section
        private void MakeGrid() // size48 10x
        {
            int x = 0;
            int y = 0;
            int a = 0;


            while (a < 11)
            {
                z.DrawLine(whitepen, 240 + x, 48, 240 + x, 527); // Draw 11 vertical lines
                a = a + 1;
                x = x + 48;
            }
            a = 0;
            while (a < 11)
            {
                z.DrawLine(whitepen, 240, 48 + y, 719, 48 + y); // Horizontal
                a = a + 1;
                y = y + 48;
            }
        }
        private void MakeBoard()             
        {
            z.FillRectangle(br2, 0.0F, 0.0F, 800.0F, 600.0F);

            z.FillRectangle(br5, 228, 36, 504, 504);
            z.FillRectangle(redbr, 236, 44, 489, 489);
            z.FillRectangle(br4, 238, 46, 484, 484);
        }
        private void UpdateScreen()          
        {

            MakeBoard();
           
            z.DrawString(cpmove.ToString(), myfont, Brushes.White, 20, 500);
            z.DrawString(dir, myfont, Brushes.White, 20, 200);
            z.DrawString(score.ToString(), myfont, Brushes.White, 110, 500);
            z.DrawString(bx.ToString(), myfont, Brushes.White, 20, 460);
            z.DrawString(by.ToString(), myfont, Brushes.White, 20, 480);
            z.DrawString(x2.ToString(), myfont, Brushes.White, 50, 460);
            z.DrawString(y2.ToString(), myfont, Brushes.White, 50, 480);
            
            UpdateScreen1();
            MakeGrid();
            Invalidate();
            Update();

        }
        private void UpdateScreen1()         
        {
            int x = 1;
            int y = 1;
            int a = 1;
            int b = 1;

            while (b < 11)
            {
                while (a < 11) // 51,  x stays < 800
                {
                    if (brd[a, b] == 1) { z.DrawImage(sp1, x+240, y+48); }
                    if (brd[a, b] == 2) { z.DrawImage(sp2, x+240, y+48); }
                    x = x + bsize;
                    a = a + 1;
                }
                b = b + 1;
                a = 1;
                x = 1;
                y = y + bsize;
            }
        }
        private void Instructions()          
        {

            z.DrawString(" ", font10, Brushes.White, 0, 100);
            z.DrawString(" ", font10, Brushes.White, 0, 118);
            z.DrawString(" ", font10, Brushes.White, 0, 136);
            z.DrawString(" ", font10, Brushes.White, 0, 154);
            z.DrawString(" ", font10, Brushes.White, 0, 172);
            z.DrawString(" ", font10, Brushes.White, 0, 190);
            z.DrawString(" ", font10, Brushes.White, 0, 208);
            z.DrawString(" ", font10, Brushes.White, 0, 226);
            z.DrawString(" ", font10, Brushes.White, 0, 244);
            z.DrawString(" ", font10, Brushes.White, 0, 262);
            z.DrawString(" ", font10, Brushes.White, 0, 280);
        }
      #endregion
     
    }
    
    public class Sounds    
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }
}