using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Diagnostics;

namespace d3dmaze
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
        }
       
        
          #region "D3D Setup Code"
          #region Declare Objects
          int btn1 = 0;
          int btn2 = 0;
          int btn3 = 0;
          int btn4 = 0;
          float x1 = 0;
          float z1 = -10;
          float x2 = 0;
          float z2 = 0;
          double dx = 0;
          double dz = 0;
          double dx2 = 0;
          double dz2 = 0;
          float angle = 3.142159f / 2f;
         
          public Device device;
          public Texture texture = null;
          public VertexBuffer m_VertexBuffer = null;
          public CustomVertex.PositionTextured[] vertice2 = new CustomVertex.PositionTextured[20];

          #endregion

          #region BitMap Section


          static Bitmap bm1 = new Bitmap(47, 47);
          Graphics b1 = Graphics.FromImage(bm1);
          static Bitmap bm2 = new Bitmap(47, 47);
          Graphics b2 = Graphics.FromImage(bm2);
          static Bitmap bm3 = new Bitmap(47, 47);
          Graphics b3 = Graphics.FromImage(bm3);
          static Bitmap bm4 = new Bitmap(47, 47);
          Graphics b4 = Graphics.FromImage(bm4);
          static Bitmap bm5 = new Bitmap(47, 47);
          Graphics b5 = Graphics.FromImage(bm5);
          static Bitmap bm6 = new Bitmap(47, 47);
          Graphics b6 = Graphics.FromImage(bm6);
          static Bitmap bm7 = new Bitmap(47, 47);
          Graphics b7 = Graphics.FromImage(bm7);
          static Bitmap bm8 = new Bitmap(22, 22);
          Graphics b8 = Graphics.FromImage(bm8);
          Image sp1 = (Image)(new Bitmap(d3dmaze.Properties.Resources.tile1));
          #endregion

        public bool InitializeGraphics()
        {
            #region present parameters section   used to make device


            PresentParameters d3dpp = new PresentParameters();
            d3dpp.Windowed = true;
            d3dpp.SwapEffect = SwapEffect.Discard;
            //d3dpp.SwapEffect = SwapEffect.Flip;
           
            d3dpp.AutoDepthStencilFormat = DepthFormat.D16;
            d3dpp.EnableAutoDepthStencil = true;

            #endregion   
            #region Make new device

            

            // Best: Hardware device and hardware vertex processing.
            try
            {
                device = new Device(0, DeviceType.Hardware, pic3d,
                    CreateFlags.HardwareVertexProcessing, d3dpp);
                Debug.WriteLine("Hardware, HardwareVertexProcessing");
            }
            catch { }

            // Good: Hardware device and software vertex processing.
            if (device == null)
            {
                try
                {
                    device = new Device(0, DeviceType.Hardware, pic3d,
                        CreateFlags.SoftwareVertexProcessing, d3dpp);
                    Debug.WriteLine("Hardware, SoftwareVertexProcessing");
                }
                catch { }
            }

            // Adequate?: Software device and software vertex processing.
            if (device == null)
            {
                try
                {
                    device = new Device(0, DeviceType.Reference, pic3d,
                        CreateFlags.SoftwareVertexProcessing, d3dpp);
                    Debug.WriteLine("Reference, SoftwareVertexProcessing");
                }
                catch (Exception ex)
                {
                    // If we still can't make a device, give up.
                    MessageBox.Show("Error initializing Direct3D\n\n" + ex.Message,
                        "Direct3D Error", MessageBoxButtons.OK);
                    return false;
                }
            }
            #endregion

            #region device.methods

            
            device.RenderState.Lighting = true;
            //device.RenderState.Lighting = false;

           
            //device.RenderState.CullMode = Cull.CounterClockwise;
            device.RenderState.CullMode = Cull.None;
            device.RenderState.ZBufferEnable = true;
           
            #endregion

            texture = Texture.FromBitmap(device, (Bitmap)sp1, Usage.None, Pool.Managed);
            #region create vertex buffer

            m_VertexBuffer = new VertexBuffer(
                                                typeof(CustomVertex.PositionTextured),
                                                80,
                                                device,
                                                0,
                                                CustomVertex.PositionTextured.Format,
                                                Pool.Managed);
            #endregion
            vertice2 = (CustomVertex.PositionTextured[])m_VertexBuffer.Lock(0, 0);
            CreateVertexData(0,0,0,1);
            CreateVertexData(6, 1, 0,1);
            m_VertexBuffer.Unlock();
            return true;
        }


        public void CreateVertexData(int a,int x,int y,int z)
        {
            vertice2[a].X = x;
            vertice2[a].Y = y;
            vertice2[a].Z = z;
            vertice2[a].Tu = 0;
            vertice2[a].Tv = 0;
            
            vertice2[a + 1].X = 0+x;
            vertice2[a + 1].Y = 1+y;
            vertice2[a + 1].Z = 0+z;
            vertice2[a + 1].Tu = 0;
            vertice2[a + 1].Tv = 1;

            vertice2[a + 2].X = 1+x;
            vertice2[a + 2].Y = 1+y;
            vertice2[a + 2].Z = 0+z;
            vertice2[a + 2].Tu = 1;
            vertice2[a + 2].Tv = 1;


            vertice2[a + 3].X = 0+x;
            vertice2[a + 3].Y = 0+y;
            vertice2[a + 3].Z = 0+z;
            vertice2[a + 3].Tu = 0;
            vertice2[a + 3].Tv = 0;

            vertice2[a + 4].X = 1+x;
            vertice2[a + 4].Y = 1+y;
            vertice2[a + 4].Z = 0+z;
            vertice2[a + 4].Tu = 1;
            vertice2[a + 4].Tv = 1;

            vertice2[a + 5].X = 1+x;
            vertice2[a + 5].Y = 0+y;
            vertice2[a + 5].Z = 0+z;
            vertice2[a + 5].Tu = 1;
            vertice2[a + 5].Tv = 0;
           
        }
        private void SetupLights()
        {
            System.Drawing.Color col = System.Drawing.Color.White;
            //Set up a material. The material here just has the diffuse and ambient
            //colors set to yellow. Note that only one material can be used at a time.
            Material mtrl = new Material();
            mtrl.Diffuse = col;
            mtrl.Ambient = col;
            device.Material = mtrl;

            //Set up a white, directional light, with an oscillating direction.
            //Note that many lights may be active at a time (but each one slows down
            //the rendering of our scene). However, here we are just using one. Also,
            //we need to set the D3DRS_LIGHTING renderstate to enable lighting

            device.Lights[0].Type = LightType.Directional;
            device.Lights[0].Diffuse = System.Drawing.Color.White;
            device.Lights[0].Direction = new Vector3((float)Math.Cos(Environment.TickCount / 250.0f), 1.0f, (float)Math.Sin(Environment.TickCount / 250.0f));

            device.Lights[0].Enabled = true;//turn it on

            //Finally, turn on some ambient light.
            //Ambient light is light that scatters and lights all objects evenly
            device.RenderState.Ambient = System.Drawing.Color.White;       //FromArgb(0x202020);
        }


      #endregion // D3D Setup Code

          #region "D3D Drawing Code"
        
          public void Render()
        {
            // Clear the back buffer.
            device.Clear(ClearFlags.Target  , Color.Black, 1, 0);
            device.Clear(ClearFlags.ZBuffer, Color.Black, 1, 0);
            device.BeginScene();
            SetupLights();
           
            SetupMatrices();
            device.SetTexture(0, texture);
            device.TextureState[0].ColorOperation = TextureOperation.Modulate;
            device.TextureState[0].ColorArgument1 = TextureArgument.TextureColor;
            device.TextureState[0].ColorArgument2 = TextureArgument.Diffuse;
            device.TextureState[0].AlphaOperation = TextureOperation.Disable;
            device.SetStreamSource(0, m_VertexBuffer, 0);

            // Tell the device the format of the vertices.
            device.VertexFormat = CustomVertex.PositionTextured.Format;

            // Draw the primitives in the data stream.
            device.DrawPrimitives(PrimitiveType.TriangleList, 0, 4);

            // End the scene and display.
            device.EndScene();
            device.Present();
        }
          
        
          private void SetupMatrices()
        {
            if (btn3 == 1)  // Forward
            {
                x1 = x1 + .1f*(float)dx;
                x2 = x2 + .1f*(float)dx;
                z1 = z1 + .1f * (float)dz;
                z2 = z2 + .1f * (float)dz;
            }
            if (btn4 == 1)  // Reverse
            {
                x1 = x1 - .1f * (float)dx;
                x2 = x2 - .1f * (float)dx;
                z1 = z1 - .1f * (float)dz;
                z2 = z2 - .1f * (float)dz;
            }
            if (btn1 == 1) angle = angle + .01F;
            if (btn2 == 1) angle = angle - .01F;
            dx = Math.Cos(angle);
            dz = Math.Sin(angle);
            //device.Transform.World = Matrix.RotationY((float)angle);
            x2 = x1+((float)dx * 10f);
            z2 = z1+((float)dz * 10f);
            device.Transform.View = Matrix.LookAtLH( // camara location and point of view
                new Vector3(x1, .5f, z1 ), // eye point
                new Vector3(x2, .5f, z2),  // point to look at
                new Vector3(0, 1, 0));     // up direction

            // Projection Matrix:
            // Perspective transformation defined by:
            //       Field of view           Pi / 4
            //       Aspect ratio            1
            //       Near clipping plane     Z = 1
            //       Far clipping plane      Z = 100
            device.Transform.Projection =
                Matrix.PerspectiveFovLH((float) 3.142 / 4f , 1, .1f, 100);
        }
          #endregion // D3D Drawing Code
        #region Events
        
        
        private void Form1_Load(object sender, EventArgs e)
        {
            //b1.FillRectangle(Brushes.Red, 2.0F, 2.0F, 46.0F, 46.0F);
           
        }

        private void button1_MouseDown(object sender, MouseEventArgs e)
        {
            btn1 = 1;
        }

        private void button2_MouseDown(object sender, MouseEventArgs e)
        {
            btn2 = 1;
        }

        private void button1_MouseUp(object sender, MouseEventArgs e)
        {
            btn1 = 0;
        }

        private void button2_MouseUp(object sender, MouseEventArgs e)
        {
            btn2 = 0;
        }

        private void button3_MouseDown(object sender, MouseEventArgs e)
        {
            btn3 = 1;
        }

        private void button3_MouseUp(object sender, MouseEventArgs e)
        {
            btn3 = 0;
        }
        
        private void button4_MouseDown(object sender, MouseEventArgs e)
        {
            btn4 = 1;
        }

        private void button4_MouseUp(object sender, MouseEventArgs e)
        {
            btn4 = 0;
        }
        #endregion

    }
}