using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Diagnostics;

namespace d3d
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
        }
        #region BitMap Section
        
        
        static Bitmap bm1 = new Bitmap(47, 47);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(47, 47);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(47, 47);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(47, 47);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(47, 47);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(47, 47);
        Graphics b6 = Graphics.FromImage(bm6);
        static Bitmap bm7 = new Bitmap(47, 47);
        Graphics b7 = Graphics.FromImage(bm7);
        static Bitmap bm8 = new Bitmap(22, 22);
        Graphics b8 = Graphics.FromImage(bm8);
        Image sp1 = (Image)(new Bitmap(d3d.Properties.Resources.piece5));
        #endregion
       
        public Device device;

        #region "D3D Setup Code"

        public Texture texture = null;
        public VertexBuffer m_VertexBuffer = null;

        
        public bool InitializeGraphics()
        {
            #region present parameters section   used to make device


            PresentParameters d3dpp = new PresentParameters();
            d3dpp.Windowed = true;
            d3dpp.SwapEffect = SwapEffect.Discard;
            //d3dpp.SwapEffect = SwapEffect.Flip;
           
            d3dpp.AutoDepthStencilFormat = DepthFormat.D16;
            d3dpp.EnableAutoDepthStencil = true;

            #endregion   
            #region Make new device

            

            // Best: Hardware device and hardware vertex processing.
            try
            {
                device = new Device(0, DeviceType.Hardware, pic3d,
                    CreateFlags.HardwareVertexProcessing, d3dpp);
                Debug.WriteLine("Hardware, HardwareVertexProcessing");
            }
            catch { }

            // Good: Hardware device and software vertex processing.
            if (device == null)
            {
                try
                {
                    device = new Device(0, DeviceType.Hardware, pic3d,
                        CreateFlags.SoftwareVertexProcessing, d3dpp);
                    Debug.WriteLine("Hardware, SoftwareVertexProcessing");
                }
                catch { }
            }

            // Adequate?: Software device and software vertex processing.
            if (device == null)
            {
                try
                {
                    device = new Device(0, DeviceType.Reference, pic3d,
                        CreateFlags.SoftwareVertexProcessing, d3dpp);
                    Debug.WriteLine("Reference, SoftwareVertexProcessing");
                }
                catch (Exception ex)
                {
                    // If we still can't make a device, give up.
                    MessageBox.Show("Error initializing Direct3D\n\n" + ex.Message,
                        "Direct3D Error", MessageBoxButtons.OK);
                    return false;
                }
            }
            #endregion

            #region device.methods

            
            device.RenderState.Lighting = true;
            //device.RenderState.Lighting = false;

           
            //device.RenderState.CullMode = Cull.CounterClockwise;
            device.RenderState.CullMode = Cull.None;
            device.RenderState.ZBufferEnable = true;
           
            #endregion

            texture = Texture.FromBitmap(device, (Bitmap)sp1, Usage.None, Pool.Managed);
            CreateVertexBuffer();
            
            return true;
        }


        public void CreateVertexBuffer()
        {
            

           
            m_VertexBuffer = new VertexBuffer(
                                                 typeof(CustomVertex.PositionColoredTextured),
                                                 80,
                                                 device,
                                                 0,
                                                 CustomVertex.PositionColoredTextured.Format,
                                                 Pool.Managed);
             
            // Lock the vertex buffer. 
            // Lock returns an array of positionColored objects.
            CustomVertex.PositionColoredTextured[] vertice2 =
                (CustomVertex.PositionColoredTextured[])m_VertexBuffer.Lock(0, 0);

////////////////            // Make the vertexes.

            vertice2[0].X = 0;
            vertice2[0].Y = 0;
            vertice2[0].Z = 0;
            vertice2[0].Tu = 0;
            vertice2[0].Tv = 0;
            vertice2[0].Color = Color.White.ToArgb();

            vertice2[1].X = 0;
            vertice2[1].Y = 1;
            vertice2[1].Z = 0;
            vertice2[1].Tu = 1;
            vertice2[1].Tv = 0;
            vertice2[1].Color = Color.White.ToArgb();

            vertice2[2].X = 1;
            vertice2[2].Y = 1;
            vertice2[2].Z = 0;
            vertice2[2].Tu = 1;
            vertice2[2].Tv = 1;
            vertice2[2].Color = Color.White.ToArgb();


            vertice2[3].X = 0;
            vertice2[3].Y = 0;
            vertice2[3].Z = 0;
            vertice2[3].Tu = 0;
            vertice2[3].Tv = 0;
            vertice2[3].Color = Color.White.ToArgb();

            vertice2[4].X = 1;
            vertice2[4].Y = 1;
            vertice2[4].Z = 0;
            vertice2[4].Tu = 1;
            vertice2[4].Tv = 1;
            vertice2[4].Color = Color.White.ToArgb();

            vertice2[5].X = 1;
            vertice2[5].Y = 0;
            vertice2[5].Z = 0;
            vertice2[5].Tu = 1;
            vertice2[5].Tv = 0;
            vertice2[5].Color = Color.White.ToArgb();


            m_VertexBuffer.Unlock();


          
        }
        private void SetupLights()
        {
            System.Drawing.Color col = System.Drawing.Color.White;
            //Set up a material. The material here just has the diffuse and ambient
            //colors set to yellow. Note that only one material can be used at a time.
            Material mtrl = new Material();
            mtrl.Diffuse = col;
            mtrl.Ambient = col;
            device.Material = mtrl;

            //Set up a white, directional light, with an oscillating direction.
            //Note that many lights may be active at a time (but each one slows down
            //the rendering of our scene). However, here we are just using one. Also,
            //we need to set the D3DRS_LIGHTING renderstate to enable lighting

            device.Lights[0].Type = LightType.Directional;
            device.Lights[0].Diffuse = System.Drawing.Color.White;
            device.Lights[0].Direction = new Vector3((float)Math.Cos(Environment.TickCount / 250.0f), 1.0f, (float)Math.Sin(Environment.TickCount / 250.0f));

            device.Lights[0].Enabled = true;//turn it on

            //Finally, turn on some ambient light.
            //Ambient light is light that scatters and lights all objects evenly
            device.RenderState.Ambient = System.Drawing.Color.White;       //FromArgb(0x202020);
        }


      #endregion // D3D Setup Code

          #region "D3D Drawing Code"
        
          public void Render()
        {
            // Clear the back buffer.
            device.Clear(ClearFlags.Target  , Color.Black, 1, 0);
            device.Clear(ClearFlags.ZBuffer, Color.Black, 1, 0);
            device.BeginScene();
            SetupLights();
           
            SetupMatrices();
            device.SetTexture(0, texture);
            device.TextureState[0].ColorOperation = TextureOperation.Modulate;
            device.TextureState[0].ColorArgument1 = TextureArgument.TextureColor;
            device.TextureState[0].ColorArgument2 = TextureArgument.Diffuse;
            device.TextureState[0].AlphaOperation = TextureOperation.Disable;
            device.SetStreamSource(0, m_VertexBuffer, 0);

            // Tell the device the format of the vertices.
            device.VertexFormat = CustomVertex.PositionColoredTextured.Format;

            // Draw the primitives in the data stream.
            device.DrawPrimitives(PrimitiveType.TriangleList, 0, 2);

            // End the scene and display.
            device.EndScene();
            device.Present();
        }
          float angle = 0;
        
          private void SetupMatrices()
        {
           
            angle = angle + .015F;
            device.Transform.World = Matrix.RotationY((float)angle);

            // View Matrix:
            // This is defined by giving:
            //       An eye point            (0, 3, -4)
            //       A point to look at      (0, 0, 0)
            //       An "up" direction       <0, 1, 0>
            device.Transform.View = Matrix.LookAtLH(
                new Vector3(0, 1, -2),
                new Vector3(0, .5f, 0),
                new Vector3(0, 1, 0));

            // Projection Matrix:
            // Perspective transformation defined by:
            //       Field of view           Pi / 4
            //       Aspect ratio            1
            //       Near clipping plane     Z = 1
            //       Far clipping plane      Z = 100
            device.Transform.Projection =
                Matrix.PerspectiveFovLH((float).75f, 1, 1, 100);
        }
          #endregion // D3D Drawing Code

        private void Form1_Load(object sender, EventArgs e)
        {
            b1.FillRectangle(Brushes.Red, 2.0F, 2.0F, 46.0F, 46.0F);
           
        }

       
    }
}